/**
 *  This file is part of RegCEL.
 *
 *  Copyright (c) 2011 2012 Yunior Barceló Chávez inf.upiv@ssp.inv.cu
 *
 *  RegCEl is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  RegCEl is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with JIM.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/
#include <QtGui>
#include "regcel_dialog.h"



RegCElDialog::RegCElDialog(QWidget *parent)
    : QDialog(parent)
{
    setupUi(this);

    QRegExp regExp("[1-9][0-9]{0,3}");
    lect_ant_LE->setValidator(new QRegExpValidator(regExp, this));
    lect_act_LE->setValidator(new QRegExpValidator(regExp, this));
    //setWindowIcon(QIcon(":/images/icon.png"))
}


void RegCElDialog::on_lect_act_LE_textChanged()
{
  run_pButton->setEnabled(1);
}

void RegCElDialog::on_run_pButton_clicked()
{
   int kw_h = 0, kw_hDisplay = 0;
   double import = 0.00;
   int rangImport;

   kw_h =  lect_act_LE->text().toInt() - lect_ant_LE->text().toInt();
   kw_hDisplay = kw_h;
   lcd_Kwh->display(kw_hDisplay);

   if (kw_h > 0 && kw_h <= 100)
       rangImport = 1;

   if (kw_h > 100 && kw_h <= 150)
       rangImport = 2;

   if (kw_h > 150 && kw_h <= 200)
       rangImport = 3;

   if (kw_h > 200 && kw_h <= 250)
       rangImport = 4;

   if (kw_h > 250 && kw_h <= 300)
       rangImport = 5;

   if (kw_h > 300)
       rangImport = 6;

   switch (rangImport) {
       case 1:
               import = (0.09 * kw_h);
               kw_h = 0;
           break;

       case 2:
               kw_h -= 100;
               import = (0.09 * 100) + (0.30 * kw_h);
               kw_h = 0;
           break;

       case 3:
               kw_h -= 150;
               import = (0.09 * 100) + (0.30 * 50) + (0.40 * kw_h);
               kw_h = 0;
            break;

       case 4: 
               kw_h -= 200;
               import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * kw_h);
               kw_h = 0;
           break;

       case 5:
               kw_h -= 250;
               import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * 50) + ( 0.80 * kw_h);
               kw_h = 0;
           break;

       case 6:
                kw_h -= 300;
                import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * 50) + ( 0.80 * 50) + (01.30 * kw_h);
                kw_h = 0;
            break;
   }

   import_lb->setText(QString("%1 $").arg(import));;
   

}

void RegCElDialog::on_help_pButton_clicked()
{
    QMessageBox::about(this, trUtf8("Ayuda"),
            trUtf8("<p>Escriba cada lectura en la caja de texto correspondiente, "
               "al introducir datos válidos el Botón ejecutar será habilitado, "
               "haga click en él y listo! ¿Fácil no? :). </p><p><b>Ejemplo:</b> Sí ayer tomó la lectura “245” en su contador eléctrico y hoy tiene la lectura “354”,"
               "en la caja de texto Lectura anterior: introdusca el primer valor: 245 y en la segunda caja de texto, "
               "pones 354 y haga click en Ejecutar.</p><p><b>Pasos: </b>"
               "1. Lecturas anterior: 245,"
	       " 2. Lectura     actual:  354,"
	       " 3. Click en ejecutar</p>"));
	       
	    


}


void RegCElDialog::on_about_pButton_clicked()
{
    QMessageBox::about(this, trUtf8("RegCEl Dialog"),
        trUtf8("<h2>RegCEl 0.0.1 (Prototipo)</h2>"
        "<h3>Registro del Consumo Eléctico</h3>"
        "<p>(C) 2012 Yunior Barceló Chávez <a href= \"mailto:inf.upiv@ssp.inv.cu\" >inf.upiv@ssp.inv.cu</a></p>"
        "<p><a href= \http://gutl.jovenclub.cu\" >http://gutl.jovenclub.cu/</a></p>"
        //"<p>Licensed under <a href= \"http://www.gnu.org/licenses/gpl.html\" >GNU General Public License version 3</a></p>"));  
        "<p>Licensed under <a href= \"http://www.gnu.org/licenses/gpl.html\" >GNU General Public License version 3</a></p>"));   
}
